test -z "$bindir" && bindir="@bindir@"
test -z "$mandir" && mandir="@mandir@"
test -z "$sysconfdir" && sysconfdir="@sysconfdir@"
+test -z "$supported_locks" && supported_locks="@supported_locks@"
test -z "$MULTIBYTE_ENABLED" && MULTIBYTE_ENABLED="@MULTIBYTE_ENABLED@"
+test -z "$ICONV_ENABLED" && ICONV_ENABLED="@ICONV_ENABLED@"
export MH_TEST_DIR auxexecdir bindir mandir sysconfdir
-export MULTIBYTE_ENABLED
+export MULTIBYTE_ENABLED ICONV_ENABLED
test -z "$MH_INST_DIR" && MH_INST_DIR="${MH_TEST_DIR}/inst"
export MH_INST_DIR
-unset MHBUILD MHCONTEXT MHMTSUSERCONF MHN MHSHOW MHSTORE MHTMPDIR
+unset MHBUILD MHCONTEXT MHMTSUSERCONF MHN MHSHOW MHSTORE
unset MHLDEBUG MHPDEBUG MHWDEBUG MM_CHARSET PAGER
+#### Use a test dir for tmp files when MHTMPDIR applies.
+MHTMPDIR=$MH_TEST_DIR/Mail
+export MHTMPDIR
+
output_md5()
{
#### Output just the checksum. If the filename needs to appear on
# note \r so next update will overwrite
printf '%3d%%\r' $PERC
}
-
+
progress_done ()
{
printf '100%%\n'
#### check() requires two arguments, each the name of a file to be
#### diff'ed.
#### If the same, the second file is removed. And the first file is
-#### removed unless the optional third argument has a value of
+#### removed unless there's an optional argument with a value of
#### 'keep first'.
#### If different, global variable "failed" is incremented.
+#### If there's an optional 'ignore space' argument, diff -b will
+#### be used instead of cmp to compare the files.
check() {
- #### POSIX diff should support -c.
- if diff -c "$1" "$2"; then
- test $# -lt 3 -o "$3" != 'keep first' && rm -f "$1"
- rm -f "$2"
+ first=$1; shift
+ second=$1; shift
+ keepfirst=
+ ignorespace=
+ while [ $# -gt 0 ]; do
+ case $1 in
+ 'keep first') keepfirst=1 ;;
+ 'ignore space') ignorespace=1 ;;
+ *) echo "$0: invalid check() argument \"$1\" in test suite" ;;
+ esac
+ shift
+ done
+
+ success=
+ if [ "$ignorespace" ]; then
+ #### POSIX diff should support -b.
+ diff -b "$first" "$second" >/dev/null && success=1
else
- echo "$0: test failed, outputs are in $1 and $2."
- failed=`expr ${failed:-0} + 1`
+ cmp -s "$first" "$second" && success=1
+ fi
+
+ if [ "$success" ]; then
+ [ "$keepfirst" ] || rm -f "$first"
+ rm -f "$second"
+ else
+ echo
+ #### POSIX diff should support -c.
+ diff -c "$first" "$second" || true
+ echo
+ echo "$0: test failed, outputs are in $first and $second."
+ failed=`expr ${failed:-0} + 1`
fi
}
{
MH="${MH_TEST_DIR}/Mail/.mh_profile"
MHMTSCONF="${MH_INST_DIR}${sysconfdir}/mts.conf"
- PATH="${MH_INST_DIR}${bindir}:${PATH}"
MH_LIB_DIR="${MH_INST_DIR}${auxexecdir}"
- export MH MHMTSCONF MH_LIB_DIR PATH
+ export MH MHMTSCONF MH_LIB_DIR
#
# Only install once
"${MHMTSCONF}.old" >"${MHMTSCONF}"
fi
+ #### On Solaris, must set PATH after the install!
+ PATH="${MH_INST_DIR}${bindir}:${PATH}"
+ export PATH
+
# clean old test data
trap "rm -rf '$MH_TEST_DIR/Mail'" 0
# setup test data
- mkdir "$MH_TEST_DIR/Mail" || exit 1
+ mkdir -p "$MH_TEST_DIR/Mail" || exit 1
cat > "$MH" <<EOF || exit 1
Path: ${MH_TEST_DIR}/Mail
buildmimeproc: ${MH_INST_DIR}${bindir}/mhbuild